<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 29/06/12
 * Time: 14:22
 * To change this template use File | Settings | File Templates.
 */
 
class RegistroHomolognet extends FPARegistro {


    const CARACTER_ATRIBUI = '=';
    const CARACTER_SEPARADOR = ';';
    const CARACTER_FINALIZADOR = '#';
    const CNPJ = '1';
    const CEI = '2';


    // Numero de meses ocorridos ate o mes de competencia. Utilizado para trazer os calculos de folha.
    const MESES_CALCULO_FOLHA = 85;

    // Usado para o grupo de incidencias
    const FALTAS_INJUSTIFICADAS = 1;
    const ADIANTAMENTO_13SALARIO = 2;
    const COMPLEMENTO_13SALARIO = 3;
    const ADIANTAMENTO_SALARIAL = 4;
    const VALE_TRANSPORTE = 15;
    const VALE_ALIMENTACAO = 6;
    const REEMBOLSO_VALE_TRANSPORTE = 7;
    const REEMBOLSO_VALE_ALIMENTACAO = 8;
    const CREDITO_CONSIGNADO = 9;
    const INDENIZACAO_ART480 = 10;
    const PREVIDENCIA_PRIVADA = 11;
    const CONTRIBUICAO_FAPI = 12;
    const CONTRIBUICAO_SINDICAL_LABORAL = 13;
    const OUTRAS_DEDUCOES_BASE_CALCULO_IRRF = 14;
//    const COMPENSACAO_DIAS_SALARIO_FERIAS_MES_AFASTAMENTO = 15;
    const COMPLEMENTACAO_IRRF_MES_QUITACAO = 16;
    const HOMOLOGNET_PENSAO_JURIDICA = 4;

    const EVENTO_FALTAS_INJUSTIFICADAS_DIAS = '1040';
    const EVENTO_FALTAS_INJUSTIFICADAS_HORAS = '1041';


    private $_tags;

    /**
     * Contrato - Gera Registro.
     *
     * @param string $tpRegistro  Numero do Tipo de Registro.
     * @param string $tpInscricao Numero do Tipo de Inscricao.
     * @param string $nrInscricao Numero da Inscricao.
     *
     * @return void
     *
     * @author alessandrobartels - 02/06/2011
     */
    protected function geraRegistro($tpRegistro, $tpInscricao, $nrInscricao)
    {
        // TODO: Implement geraRegistro() method.
    }


    private function _preparaRegistroHomolognet($registro){
        $this->_tags = array();
        $itens = explode(self::CARACTER_SEPARADOR, $registro);
        $i = 1;
        foreach ($itens as $item) {
            list($no, $valor) = explode(self::CARACTER_ATRIBUI, $item);
                $this->_tags[$no.$i] = $valor;
            $i++;
        }
    }


   /* public function getTags(){
        return $this->_tags;
    }*/


    public function geraTag(XMLWriter $xml){
        $registro = $this->getLinhaRegistro();
        $this->_preparaRegistroHomolognet($registro);

        foreach ($this->_tags as $tag => $valor){

            $substr = substr($tag, 0, 1);
            if ((string)self::CARACTER_FINALIZADOR !== (string)$substr) {
                $replace = '/[^a-zA-Z\s]/';
                $tag = preg_replace($replace,'',$tag);

                // Corrigindo o replace para a tag 'VLAdiantamento13Salario'
                ($tag == 'VLAdiantamentoSalario') ? $tag = RegistroDescontoHomolognet::VALOR_ADIANTAMENTO_13_SALARIO : '';

            } else {
                $tag = substr($tag, 0, 1);
            }

            if ($tag !== self::CARACTER_FINALIZADOR){
                $xml->startElement($tag);
                if (empty($valor) === false){
                    $xml->text($valor);
                    $xml->endElement();
                    /*$elemento = $dominio->createElement($tag, $valor);
                    $noPrincipal->appendChild($elemento);*/
                }
            } else {
                $xml->endElement();
            }
        }

    }

}
